#!/usr/bin/env python

from MoinMessage import Message, GPG, sendMessage
from email.mime.application import MIMEApplication
from os.path import split
import sys

def readfile(filename):
    f = open(filename, "rb")
    try:
        return MIMEApplication(f.read())
    finally:
        f.close()

if __name__ == "__main__":
    try:
        recipient = sys.argv[1]
        signer = sys.argv[2]
        url = sys.argv[3]
        args = sys.argv[4:]
    except IndexError:
        args = None

    if not args:
        print >>sys.stderr, """\
Need a recipient key identifier, signing key identifier, the destination URL,
and some filenames for transfer as arguments to this program.
"""
        sys.exit(1)

    # Bundle files into a message.

    message = Message()

    for arg in args:
        part = readfile(arg)
        part["Content-Disposition"] = split(arg)[-1]
        part["Update-Action"] = "store"
        message.add_update(part)

    # Get the e-mail message itself.

    message = message.get_payload()

    # Encrypt, sign and send the message.

    gpg = GPG()
    message = gpg.encryptMessage(message, recipient)
    message = gpg.signMessage(message, signer)
    resp = sendMessage(message, url)

    print resp

# vim: tabstop=4 expandtab shiftwidth=4
